// This is an IBM-authored function -- not provided by eCap
function startCountDown(timeOutPage)
{
	// warn user 13 minutes after page is loaded -- 2 minutes before
	// WebSphere and eCap sessions time out
	setTimeout("sessionTimeOutWarning('"+timeOutPage+"')", 13*60*1000);
}
function sessionTimeOutWarning(timeOutPage)
{
	// redirect to timed out page in 2 minutes
	setTimeout("window.location.href='"+timeOutPage+"'", 2*60*1000);
	beforeWarningTime = new Date().getTime();
	if (window.showModalDialog)
		window.showModalDialog("/ds/jsps/timedOutWarning.jsp",null,"dialogHeight:125px;dialogWidth:600px;resizable:0;status:0;help:0;center:1");
	else
		warningWin=window.open("/ds/jsps/timedOutWarning.jsp","","height=125,width=600,left=200,top=300,resizable=0,status=0");
	afterWarningTime = new Date().getTime();
	// if user doesn't dismiss warning dialog within 2 minutes, this will
	// redirect them promptly
	if (afterWarningTime-beforeWarningTime > 2*60*1000)
		window.location.href=timeOutPage;
}


function c_MaintainSessionLightEcap()
{
  var ECAP_LOGIN_COOKIE = "LoggedIn";
  var ECAP_SESSIONID_COOKIE = "ecapSession";
  var ECAP_SESSION_TIMEOUT = 15;
  
  // check for non-expired cookie existance
  var loginCookie = c_GetCookieValueEcap(ECAP_LOGIN_COOKIE);
  var sessionCookie = c_GetCookieValueEcap(ECAP_SESSIONID_COOKIE);
  var dNow = new Date();
  var dExpires = new Date();
  dExpires.setMinutes( dNow.getMinutes() + ECAP_SESSION_TIMEOUT );

  if (loginCookie != null && (sessionCookie != "" || sessionCookie != null))
  {
    var eCapCookieString = ECAP_LOGIN_COOKIE + "=" + loginCookie + ";expires=" + dExpires.toGMTString() + ";path=/;" + "domain=.usps.com" ;
    document.cookie = eCapCookieString;
  }
  else
  {
    // User is not logged in
    if (sessionCookie != "" && sessionCookie != null)
    {
      var eCapCookieString = ECAP_SESSIONID_COOKIE + "=;" + "path=/;" + "domain=.usps.com;secure" ;
      document.cookie = eCapCookieString;
    }
    if (loginCookie != null)
    {
      var eCapCookieString = ECAP_LOGIN_COOKIE + "=;expires=" + dNow.toGMTString() + ";path=/;" + "domain=.usps.com" ;
      document.cookie = eCapCookieString;
    }
  }
}

function c_GetCookieValueEcap(name)
{
  var theCookie = document.cookie;
  var argument = name + "=";
  var argLen = argument.length;
  var cookieLen = theCookie.length;

  var i = 0;
  while (i < cookieLen)
  {
    var j = i + argLen;
    if (theCookie.substring(i,j) == argument)
    {
      var endStr = theCookie.indexOf(";",j);
      if (endStr == -1)
      {
        endStr = theCookie.length;
      }

      return theCookie.substring(j,endStr);
    }
    i = theCookie.indexOf(" ",i) + 1;
    if (i == 0)
    {
      break;
    }
  }

  return null;
}

function deleteCookies()
{
  var ECAP_LOGIN_COOKIE = "LoggedIn";
  var loginCookie = c_GetCookieValueEcap(ECAP_LOGIN_COOKIE);
  var eCapCookieString = ECAP_LOGIN_COOKIE + "=" + loginCookie + "LOGOFF_FLAG" + ";expires=" + "ZZZZZZZZZZZZ" + ";path=/;" + "domain=.usps.com";
  document.cookie = eCapCookieString;
}
