<?php
/*
  $Id: auction_lister.php,v 1.3 2004/09/23 04:29:03 auctionblox Exp $
 
  osCommerce, Open Source E-Commerce Solutions
  http://www.oscommerce.com
 
  Copyright (c) 2003 osCommerce
  
  This file is part of the eBay Auction Manager for osCommerce
  http://www.auctionblox.com/oscommerce
 
  Copyright (c) 2003, AuctionBlox.com  
 
  Released under the GNU General Public License
*/

  require('includes/application_top.php');
  
  require(DIR_WS_CLASSES . 'currencies.php');
  $currencies = new currencies();  

  require(DIR_WS_CLASSES . 'auction_lister.php');
  $auctionLister = new AuctionLister();
  
  require(DIR_WS_CLASSES . 'auction_constants.php');
  $auctionConstants = new auctionConstants;
  
  $insuranceOptions = $auctionConstants->getInsuranceOptions();
  $shippingTypes = $auctionConstants->getShippingTypes();
  $listingTypes = $auctionConstants->getListingTypes();
  $sites = $auctionConstants->getSites();
  $durations = $auctionConstants->getListingDurations();
  $currencylist = $auctionConstants->getCurrencies();
  $shippingLocations = $auctionConstants->getShippingLocations();
  $regions = $auctionConstants->getRegions();
  $galleryOptions = $auctionConstants->getGalleryOptions();
  
  $storeCategories = $auctionLister->getStoreCategories();
  
	$products[] = array('id' => '0', 'text' => '[No product selected]');
	$products_query = tep_db_query("select pd.products_id, pd.products_name from " . TABLE_PRODUCTS_DESCRIPTION . " pd where pd.language_id = '" . $languages_id . "' order by pd.products_name");			
	while ($product = tep_db_fetch_array($products_query))
	{
		$products[] = array('id' => $product['products_id'],
        	                'text' => $product['products_name']);
	}		

  switch($_REQUEST['perform'])
  {
    case 'editTemplate':
		$oListing = $auctionLister->getTemplate($_REQUEST['oID']);
		break;

	case 'copyTemplate':
		$oListing = $auctionLister->getTemplate($_REQUEST['oID']);
		break;
    
	case 'createListing':
		$oListing = $auctionLister->getTemplate($_REQUEST['oID']);
		break;

    case 'editListing':
		$oListing = $auctionLister->getListing($_REQUEST['oID']);
		break;
   
   case 'copyListing':
		$oListing = $auctionLister->getListing($_REQUEST['oID']);
		break;

    case 'editUpload':
		$oListing = $auctionLister->getUpload($_REQUEST['oID']);
		break;

    case 'save':
	  if(isset($HTTP_GET_VARS['perform']) && $HTTP_GET_VARS['perform'] === 'editListing' && isset($HTTP_GET_VARS['oID']))
	  {
		  $id = $auctionLister->updateListing($HTTP_POST_VARS, $HTTP_GET_VARS['oID']);
		  tep_redirect(tep_href_link(FILENAME_AUCTION_SAVED, tep_get_all_get_params(array('perform', 'action', 'status', 'oID')).'oID='.$id));
	  }
	  else if(isset($HTTP_GET_VARS['perform']) && $HTTP_GET_VARS['perform'] === 'editUpload' && isset($HTTP_GET_VARS['oID']))
	  {
		  $auctionLister->updateUpload($HTTP_POST_VARS, $HTTP_GET_VARS['oID']);
		  tep_redirect(tep_href_link(FILENAME_AUCTION_UPLOADS, tep_get_all_get_params(array('perform', 'action', 'status'))));
	  }
	  else if(isset($HTTP_GET_VARS['perform']) && $HTTP_GET_VARS['perform'] === 'editTemplate' && isset($HTTP_GET_VARS['oID']))
	  {
		  $auctionLister->updateTemplate($HTTP_POST_VARS, $HTTP_GET_VARS['oID']);
		  tep_redirect(tep_href_link(FILENAME_AUCTION_TEMPLATES, tep_get_all_get_params(array('perform', 'action', 'status'))));
	  }
	  else if(isset($HTTP_GET_VARS['perform']) && $HTTP_GET_VARS['perform'] === 'createTemplate')
	  {
		  $auctionLister->insertTemplate($HTTP_POST_VARS);
		  tep_redirect(tep_href_link(FILENAME_AUCTION_TEMPLATES, tep_get_all_get_params(array('perform', 'action', 'status'))));
	  }
	  else if(isset($HTTP_GET_VARS['perform']) && $HTTP_GET_VARS['perform'] === 'copyTemplate')
	  {
		  $id = $auctionLister->insertTemplate($HTTP_POST_VARS);
		  tep_redirect(tep_href_link(FILENAME_AUCTION_TEMPLATES, tep_get_all_get_params(array('perform', 'action', 'status', 'oID')).'oID='.$id));
	  }
	  else if(isset($HTTP_GET_VARS['perform']) && $HTTP_GET_VARS['perform'] === 'copyListing')
	  {
		  $id = $auctionLister->insertListing($HTTP_POST_VARS);
		  tep_redirect(tep_href_link(FILENAME_AUCTION_SAVED, tep_get_all_get_params(array('perform', 'action', 'status', 'oID')).'oID='.$id));
	  }
	  else
	  {
		  $id = $auctionLister->insertListing($HTTP_POST_VARS);
		  tep_redirect(tep_href_link(FILENAME_AUCTION_SAVED, tep_get_all_get_params(array('perform', 'action', 'status', 'oID')).'oID='.$id));
	  }
	  break;

	default:
//	  debugbreak();
	  if(isset($_REQUEST['oID']))
	  {
	    $auctionLister = new AuctionLister();
		$oListing = $auctionLister->getTemplate($_REQUEST['oID']);
	  }
	  else
		$oListing = array(
			'quantity' => '1',
			'duration' => '7');

	  break;
  }

?>
<!doctype html public "-//W3C//DTD HTML 4.01 Transitional//EN">
<html <?php echo HTML_PARAMS; ?>>
<head>
<meta http-equiv="Content-Type" content="text/html; charset=<?php echo CHARSET; ?>">
<title><?php echo TITLE; ?></title>
<link rel="stylesheet" type="text/css" href="includes/stylesheet.css">

  <script language="Javascript1.2"><!-- // load htmlarea
  //MaxiDVD Added WYSIWYG HTML Area Box + Admin Function v1.6.5 Products Description HTML - Head
        _editor_url = "<?php echo (($request_type == 'SSL') ? HTTPS_SERVER : HTTP_SERVER) . DIR_WS_ADMIN; ?>htmlarea/";  // URL to htmlarea files
          var win_ie_ver = parseFloat(navigator.appVersion.split("MSIE")[1]);
           if (navigator.userAgent.indexOf('Mac')        >= 0) { win_ie_ver = 0; }
            if (navigator.userAgent.indexOf('Windows CE') >= 0) { win_ie_ver = 0; }
             if (navigator.userAgent.indexOf('Opera')      >= 0) { win_ie_ver = 0; }
         if (win_ie_ver >= 5.5) {
         document.write('<scr' + 'ipt src="' +_editor_url+ 'editor_basic.js"');
         document.write(' language="Javascript1.2"></scr' + 'ipt>');
         } else { 
		 document.write('<scr'+'ipt>function editor_generate() { return false; }</scr'+'ipt>'); 
		 }
--></script>

  <script language="Javascript1.2">
  		self.setTimeout('loadHTMLArea()', 0);
		
		function loadHTMLArea()
		{
			if(document.all.description == null)
				self.setTimeout('loadHTMLArea()', 500);
			else
			{
	          // MaxiDVD Added WYSIWYG HTML Area Box + Admin Function v1.6.5 Products Description HTML - Body
	             // More Configs can added here:
    	         // Dreamscape added Dynamic Language Function

    	         var config2 = new Object();  // create new config object
        	     config2.width = "600px";
            	 config2.height = "500px";

				 //+++AUCTIONBLOX.COM Disable editor if source contains any SCRIPT tags
				 if( document.all.description.value.search(/script/i) < 0)
				 {
    	    	     editor_generate('description',config2);
					 document.all.diveditorenabled.style.display = "";
				 }
				 else
				 {
					 document.all.diveditordisabled.style.display = "";
				 }
			 }
		}
   </script>
  
<script language="javascript">
	function switchmode(mode)
	{
		if(mode == "textmode")
		{
			editor_setmode('description', 'textedit');
		}
		else
		{
			if( editor_getHTML('description').search(/script/i) > 0)
			{
				alert("The HTML editor cannot be displayed because your description contains JavaScript");
				//editor_setmode('description', 'textedit');
			}
			else
			{
				editor_setmode('description', 'wysiwyg');
			}
		}
	}

	function selectcat(id)
	{
		val = window.open('auction_categories_client.php?e='+id+'&s='+document['listings']['site'].value, 'categories', 'width=500, height=585, location=no, menubar=no, toolbar=no, status=no, resizable=yes, scrollbars=yes');
	}
	
	function changeSite()
	{
		if((document['listings']['category1'] != null && document['listings']['category1'].value.length > 0) ||
		   (document['listings']['category2'] != null && document['listings']['category2'].value.length > 0))
		{
			alert('<?php echo TEXT_CATEGORIES_DIFFER ?>'); 
		}
		
		document['listings']['category1'].value = '';
		document['listings']['category2'].value = '';
	}

	function submit_form(perform)
	{
	    document.forms['listings'].action = '<? echo FILENAME_AUCTION_LISTER.'?'.tep_get_all_get_params(array('action')); ?>';
		if(perform == 'schedule')
		{
			document.forms['listings'].action = '<? echo FILENAME_AUCTION_SCHEDULER; ?>';
		}
		else if(perform == 'preview')
		{
			document.forms['listings'].action = '<? echo FILENAME_AUCTION_PREVIEW; ?>';
			document.forms['listings'].target = '_preview';
		}
		//alert(perform);
		document.forms['listings'].perform.value = perform;
		document.forms['listings'].submit();
		return false;
	}
	
	function show(divID)
	{
 
	  if(document.all)
	  {
		  document.all.divbasics.style.display = "none";
		  document.all.divpayment.style.display = "none";
		  document.all.divshipping.style.display = "none";
		  document.all.divdescription.style.display = "none";
		  document.all.divother.style.display = "none";
		  document.all[divID].style.display="block";
	  }else if(document.getElementById){
		document.getElementById('divbasics').style.display = "none";
		document.getElementById('divpayment').style.display = "none";
		document.getElementById('divshipping').style.display = "none";
		document.getElementById('divdescription').style.display = "none";
		document.getElementById('divother').style.display = "none";
		document.getElementById(divID).style.display="";
	  }
	}
</script>
</head>
<body marginwidth="0" marginheight="0" topmargin="0" bottommargin="0" leftmargin="0" rightmargin="0" bgcolor="#FFFFFF">
<!-- header //-->
<?php
  require(DIR_WS_INCLUDES . 'header.php');
?>
<!-- header_eof //-->

<!-- body //-->
<table border="0" width="100%" cellspacing="2" cellpadding="2">
  <tr>
    <td width="<?php echo BOX_WIDTH; ?>" valign="top"><table border="0" width="<?php echo BOX_WIDTH; ?>" cellspacing="1" cellpadding="1" class="columnLeft">
<!-- left_navigation //-->
<?php require(DIR_WS_INCLUDES . 'column_left.php'); ?>
<!-- left_navigation_eof //-->
    </table></td>
<!-- body_text //-->
	<?php echo tep_draw_form("listings", FILENAME_AUCTION_LISTER, tep_get_all_get_params(array('action')), 'POST') ?>
	<?php echo tep_draw_hidden_field("country", $auctionLister->getCountryIsoCode2()); ?>
    <td width="100%" valign="top"><table border="0" width="100%" cellspacing="0" cellpadding="2">
      <tr>
        <td width="100%"><table border="0" width="100%" cellspacing="0" cellpadding="0">
          <tr>
            <td class="pageHeading"><?php echo HEADING_TITLE ?></td>
            <td class="pageHeading" align="right">
			  <input type="hidden" name="perform">
			  <?php echo tep_image_button('button_preview.gif', IMAGE_PREVIEW, "onclick=\"return submit_form('preview');\"") ?>
			  <?php echo tep_image_button('button_save.gif', IMAGE_SAVE, "onclick=\"return submit_form('save');\"") ?>
              <?php if(!isset($HTTP_GET_VARS['perform']) || $HTTP_GET_VARS['perform'] !== 'editUpload') echo tep_image_button('button_upload.gif', IMAGE_UPLOAD, "onclick=\"return submit_form('schedule');\"") ?>
			</td>
          </tr>
        </table></td>
      </tr>
      <tr>
        <td><?php echo tep_draw_separator('pixel_trans.gif', '1', '10'); ?></td>
      </tr>
      <tr>
        <td><table border="0" cellspacing="0" cellpadding="2">
          <tr>
            <td valign="top"><a href="#" onclick="show('divbasics')"><u><?php echo TEXT_BASICS ?></u></a></td>
            <td valign="top"><a href="#" onclick="show('divpayment')"><u><?php echo TEXT_PAYMENT ?></u></a></td>
            <td valign="top"><a href="#" onclick="show('divshipping')"><u><?php echo TEXT_SHIPPING ?></u></a></td>
            <td valign="top"><a href="#" onclick="show('divdescription')"><u><?php echo TEXT_DESCRIPTION ?></u></a></td>
            <td valign="top"><a href="#" onclick="show('divother')"><u><?php echo TEXT_OTHER ?></u></a></td>
		  </tr>
		</table></td>
      <tr>
        <td class="formArea"><table border="0" cellspacing="2" cellpadding="2">
          <tr>
            <td valign="top">
				<div id="divbasics">
				<table border="0" width="100%" cellspacing="0" cellpadding="0">
				<tr>
			        <td><table border="0" cellspacing="2" cellpadding="2">
				<?  
				    if(isset($HTTP_GET_VARS['perform']) && stristr($HTTP_GET_VARS['perform'], 'template') !== false)
					{
					   echo '<tr>';
    	               echo '<td class="main" align="right">' . ENTRY_TEMPLATE_NAME . '</td>';
        	           echo '<td class="main">' . tep_draw_input_field('name', $oListing['name'], 'size="32" maxlength="32"', true) . '</td>';
					   echo '</tr>';
					}
				?>
	            <tr>
				  <td class="main" align="right"><?php echo ENTRY_PRODUCT ?></td>
		          <td class="main"><?php echo tep_draw_pull_down_menu('products_id', $products, $oListing['products_id']); ?></td>
				  
				</tr>
				<tr>
                  <td class="main" align="right"><?php echo ENTRY_TITLE ?></td>
                  <td class="main"><?php echo tep_draw_input_field('title', $oListing['title'], 'size="55" maxlength="55"', true); ?></td>
				</tr>
				<tr>
                  <td class="main" align="right"><?php echo ENTRY_SUBTITLE ?></td>
                  <td class="main"><?php echo tep_draw_input_field('subtitle', $oListing['subtitle'], 'size="55" maxlength="55"', false); ?><font color="green">&nbsp;$&nbsp;<a target="_blank" href="http://pages.ebay.com/help/sell/fees.html">fees</a></font></td>
				</tr>
					  </tr>
					</table></td>					  
				<tr>
				  <td><?php echo tep_draw_separator('pixel_trans.gif', '1', '10'); ?></td>
				</tr>
				<tr>
			        <td><table border="0" cellspacing="2" cellpadding="2">
				        <tr>
		        	        <td class="main" align="right"><?php echo ENTRY_LISTING_TYPE ?></td>
    			            <td class="main"><?php echo tep_draw_pull_down_menu('listing_type', $listingTypes, $oListing['listing_type']);?></td>
						</tr>
						<tr>
							<td class="main" align="right"><?php echo ENTRY_SITE ?></td>
							<td class="main"><?php echo tep_draw_pull_down_menu('site', $sites, $oListing['site'], 'onchange="changeSite();"');?></td>
					  	</tr>
						<tr>
							<td class="main" align="right"><?php echo ENTRY_LOCATION ?></td>
							<td class="main"><?php echo tep_draw_input_field('city_state', $oListing['city_state'], 'size="32" maxlength="64"', false); ?>
							<?php echo TEXT_HELP_LOCATION ?>
							</td>
					  	</tr>
<!--						<tr>
							<td class="main" align="right">Region</td>
							<td class="main"><?php //echo tep_draw_pull_down_menu('region', $regions, $oListing->region);?></td>
					  	</tr>
-->					</table></td>					  
				</tr>
				<tr>
				  <td><?php echo tep_draw_separator('pixel_trans.gif', '1', '10'); ?></td>
				</tr>
				<tr>
			        <td><table border="0" cellspacing="2" cellpadding="2">
			          <tr>
		                  <td class="main" align="right"><?php echo ENTRY_CATEGORY1 ?></td>
        		          <td class="main"><?php echo tep_draw_input_field('category1', $oListing['category1'], 'size="8" maxlength="12"', true); ?></td>
        		          <td class="main"><a href="#" onclick="selectcat('category1');"><u><?php echo TEXT_CATEGORY_FIND ?></u></a></td>
					  </tr>
					  </tr>						  
		                  <td class="main" align="right"><?php echo ENTRY_CATEGORY2 ?></td>
        		          <td class="main"><?php echo tep_draw_input_field('category2', $oListing['category2'], 'size="8" maxlength="12"', false); ?></td>
        		          <td class="main"><a href="#" onclick="selectcat('category2');"><u><?php echo TEXT_CATEGORY_FIND ?></u></a></td>
					  </tr>
					  </tr>						  
		                  <td class="main" align="right"><?php echo ENTRY_STORE_CATEGORY ?></td>
        		          <td class="main"><?php echo tep_draw_pull_down_menu('store_category', $storeCategories, $oListing['store_category']); ?></td>
					  </tr>
					</table></td>					  
				</tr>
				<tr>
				  <td><?php echo tep_draw_separator('pixel_trans.gif', '1', '10'); ?></td>
				</tr>
				<tr>
			        <td><table border="0" cellspacing="2" cellpadding="2">
			          <tr>
		                  <td class="main" align="right"><?php echo ENTRY_DURATION ?></td>
        		          <td class="main"><?php echo tep_draw_pull_down_menu('duration', $durations, $oListing['duration']);?></td>
					  </tr>
			          <tr>
		                  <td class="main" align="right"><?php echo ENTRY_QUANTITY ?></td>
							<td class="main"><?php echo tep_draw_input_field('quantity', $oListing['quantity'], 'maxlength="5"', false); ?></td>
					  </tr>
					</table></td>					  
				</tr>
				</table>		
				</div>
				<div id="divpayment" style="display:none">
				<table border="0" width="100%" cellspacing="0" cellpadding="0">
				<tr>
			        <td><table border="0" cellspacing="2" cellpadding="2">
						<tr>
		                  <td class="main" align="right"><?php echo ENTRY_MINIMUM_BID ?></td>
        		          <td class="main"><?php echo tep_draw_input_field('price', $oListing['price'], 'maxlength="10"', true); ?></td>
						</tr>
						<tr>
		                  <td class="main" align="right"><?php echo ENTRY_BIN_PRICE ?></td>
        		          <td class="main"><?php echo tep_draw_input_field('bin_price', $oListing['bin_price'], 'maxlength="10"', false); ?></td>
						</tr>
						<tr>
        	    	      <td class="main" align="right"><?php echo ENTRY_RESERVE_PRICE ?></td>
            	    	  <td class="main"><?php echo tep_draw_input_field('reserve_price', $oListing['reserve_price'], 'maxlength="10"', false); ?></td>
						</tr>
						<tr>
						  <td><?php echo tep_draw_separator('pixel_trans.gif', '1', '10'); ?></td>
						</tr>
					  </tr>
					</table></td>
				</tr>
<?php
		      if (STORE_COUNTRY == 223) {	// 223 == US
				echo '<tr>';
				echo '<td><table border="0" cellspacing="2" cellpadding="2">';
				echo '<tr>';
                echo '<td class="main">' . ENTRY_SALES_TAX;
				require_once(DIR_WS_FUNCTIONS . 'ustaxregions.php');
				echo '<select name="sales_tax_state">';
				state_list($oListing['sales_tax_state']);
				echo '</select>';
				echo '&nbsp;' . tep_draw_input_field('sales_tax_percent', $oListing['sales_tax_percent'], 'size=6', false) . '&nbsp;%';
				echo '</td>';
				echo '</tr>';
				echo '<tr>';
	        	echo '<td class="main">';
				echo tep_draw_checkbox_field('sales_tax_sandh', '1', false, $oListing['sales_tax_sandh']);
				echo TEXT_TAX_SANDH . '</td>';
				echo '</tr>';
				echo '<tr><td>';
				echo tep_draw_separator('pixel_trans.gif', '1', '10'); 
				echo '</td></tr>';
				echo '</table></td>';
				echo '</tr>';
			  }
			  else
			  {
				echo '<tr>';
				echo '<td><table border="0" cellspacing="2" cellpadding="2">';
				echo '<tr>';
                echo '<td class="main">'. ENTRY_VAT_RATE;
				echo '&nbsp;' . tep_draw_input_field('sales_tax_percent', $oListing['sales_tax_percent'], 'size=6', false) . '&nbsp;%';
				echo '</td>';
				echo '</tr>';
				echo '<tr><td>';
				echo tep_draw_separator('pixel_trans.gif', '1', '10'); 
				echo '</td></tr>';
				echo '</table></td>';
				echo '</tr>';
			  }
?>			  
				<tr>							  
			        <td><table border="0" cellspacing="2" cellpadding="2">
						<tr>
                		  <td colspan="4" class="main"><?php echo TEXT_PAYMENT_METHODS ?></td>
						</tr>
						<tr>
							<td class="main">
							  <?php echo tep_draw_checkbox_field('paypal_accepted', '1', false, $oListing['paypal_accepted']) . ENTRY_PAYPAL; ?>
							</td>
			                <td class="main" align="right"><?php echo ENTRY_PAYPAL_EMAIL ?></td>
            			    <td class="main"><?php echo tep_draw_input_field('paypal_email', $oListing['paypal_email'], 'size="32" maxlength="64"', false); ?></td>
						</tr>
						<tr>
							<td colspan="2" class="main">
							<?php echo tep_draw_checkbox_field('paypal_immediate_pay', '1', false, $oListing['paypal_immediate_pay']) . ENTRY_PAYPAL_IMMED_PAY; ?>
							</td>
						</tr>
					</table></td>					  
				</tr>
				<tr>
			        <td><table border="0" cellspacing="2" cellpadding="2">
						<tr>
		                  <td class="main"><?php echo tep_draw_checkbox_field('payment_mastercard_visa', '1', false, $oListing['payment_mastercard_visa']) . ENTRY_VISAMASTER; ?></td>
		                  <td class="main"><?php echo tep_draw_checkbox_field('payment_cod', '1', false, $oListing['payment_cod']) . ENTRY_COD ;?></td>
						</tr>
						<tr>
            		      <td class="main"><?php echo tep_draw_checkbox_field('payment_amex', '1', false, $oListing['payment_amex']) . ENTRY_AMEX; ?></td>
    	            	  <td class="main"><?php echo tep_draw_checkbox_field('payment_discover', '1', false, $oListing['payment_discover']) . ENTRY_DISCOVER; ?></td>
						</tr>
						<tr>
            		      <td class="main"><?php echo tep_draw_checkbox_field('payment_moneyorder_cashiers', '1', false, $oListing['payment_moneyorder_cashiers']) . ENTRY_MOCASHIERS; ?></td>
            		      <td class="main"><?php echo tep_draw_checkbox_field('payment_check', '1', false, $oListing['payment_check']) . ENTRY_CHECK; ?></td>
						</tr>
						<tr>
    	            	  <td class="main"><?php echo tep_draw_checkbox_field('payment_other', '1', false, $oListing['payment_other']) . ENTRY_OTHER; ?></td>
						</tr>
					</table></td>					  
				</tr>
				<tr>
				  <td><?php echo tep_draw_separator('pixel_trans.gif', '1', '10'); ?></td>
				</tr>
				<tr>
			        <td><table border="0" cellspacing="2" cellpadding="2">
						<tr>
    	    	          <td class="main"><?php echo TEXT_PAYMENT_INSTRUCTIONS ?></td>
						</tr>
						<tr>
	            	      <td class="main"><?php echo tep_draw_textarea_field('payment_description', true, 65, 10, $oListing['payment_description']); ?></td>
						</tr>
					</table></td>					  
				</tr>
				</table>
				</div>		
				<div id="divshipping" style="display:none">
				<table border="0" width="100%" cellspacing="0" cellpadding="0">
				<tr>
			        <td><table border="0" cellspacing="2" cellpadding="2">
					<tr>
        	          <td class="main" align="right"><?php echo ENTRY_SHIPPING_LOCATION ?></td>
    	              <td class="main"><?php echo tep_draw_pull_down_menu('shipping_location', $shippingLocations, $oListing['shipping_location']); ?></td>
					</tr>
					<tr>
        		      <td class="main" align="right"><?php echo ENTRY_SHIPPING_TYPE ?></td>
    	              <td class="main"><?php echo tep_draw_pull_down_menu('shipping_type', $shippingTypes, $oListing['shipping_type']); ?></td>
					</tr>
					</table></td>					  
				</tr>
				<tr>
			        <td><table border="0" cellspacing="2" cellpadding="2">
						<tr>
		                  <td colspan="4" class="main"><?php echo ENTRY_SHIPPING_COST ?></td>
						</tr>
						<tr>
		                  <td class="main"><?php echo ENTRY_SHIPPING_FIRST_ITEM ?></td>
        		          <td class="main"><?php echo tep_draw_input_field('shipping', $oListing['shipping'], '', false); ?></td>
		                  <td class="main"><?php echo ENTRY_SHIPPING_ADDL_ITEM ?></td>
		                  <td class="main"><?php echo tep_draw_input_field('shipping_addl', $oListing['shipping_addl'], '', false); ?></td>
						</tr>
					</table></td>
				</tr>
				<tr>
				  <td><?php echo tep_draw_separator('pixel_trans.gif', '1', '10'); ?></td>
				</tr>
				<tr>
			        <td><table border="0" cellspacing="2" cellpadding="2">
						<tr>
		                  <td class="main" align="right"><?php echo ENTRY_INSURANCE_OPTION ?></td>
        		          <td class="main"><?php echo tep_draw_pull_down_menu('insurance_option', $insuranceOptions, $oListing['insurance_option']); ?></td>
						</tr>
						<tr>
                		  <td class="main" align="right"><?php echo ENTRY_INSURANCE ?></td>
		                  <td class="main"><?php echo tep_draw_input_field('insurance', $oListing['insurance'], '', false); ?></td>
						</tr>
					</table></td>
				</tr>
				<tr>
				  <td><?php echo tep_draw_separator('pixel_trans.gif', '1', '10'); ?></td>
				</tr>
				<tr>
			        <td><table border="0" cellspacing="2" cellpadding="2">
						<tr>
    	    	          <td class="main"><?php echo ENTRY_SHIPPING_INSTRUCTIONS ?></td>
						</tr>
						<tr>
	            	      <td class="main"><?php echo tep_draw_textarea_field('shipping_description', true, 65, 10, $oListing['shipping_description']); ?></td>
						</tr>
					</table></td>					  
				</tr>
				</table>	
				</div>				
				<div id="divdescription" style="display:none">
				<div id="diveditordisabled" style="display:none">
				<table border="0" cellspacing="0" cellpadding="0">
				<tr>
    	          <td class="messageStackError"><br><?php echo TEXT_DESIGNER_MODE_DISABLED ?><br></td>
				</tr>
				</table>								
				</div>
				<div id="diveditorenabled" style="display:none">
				<table border="0" cellspacing="0" cellpadding="0">
				<tr>
    	          <td class="main"><input type="radio" name="mode" value="0" checked="unused" onclick="switchmode('wysiwyg')"><?php echo ENTRY_DESIGNER_MODE_DESIGNER ?></td>
    	          <td class="main"><input type="radio" name="mode" value="1" onclick="switchmode('textmode')"><?php echo ENTRY_DESIGNER_MODE_HTML?></td>
				</tr>
				</table>								
				</div>
				<table border="0" width="100%" height="600" cellspacing="0" cellpadding="0">
				<tr>
           	      <td class="main"><?php echo tep_draw_textarea_field('description', true, 100, 82, $oListing['description'], "id='description'"); ?></td>
			    </tr>
				</table>								
				</div>
				<div id="divother" style="display:none">
				<table border="0" width="100%" cellspacing="0" cellpadding="0">
					<tr>
	                  <td class="main"><?php echo ENTRY_GALLERY_OPTION ?>
			          <?php echo tep_draw_pull_down_menu('extra_gallery', $galleryOptions, $oListing['extra_gallery']); ?></td>
	        	        <td class="main">
						<?php echo tep_draw_hidden_field("extra_gallery_url", $oListing['extra_gallery_url']); ?>
						<?php
							if(strlen($oListing['extra_gallery_url']) === 0)
								echo tep_image_button("noimage.gif", IMAGE_NOIMAGE, "name=\"extra_gallery_image\" onclick=\"var x = prompt('" . TEXT_GALLERY_URL . "', document.forms['listings'].extra_gallery_url.value); if(x && x.length > 0) { document.forms['listings'].extra_gallery_url.value = x; document.forms['listings'].extra_gallery_image.src = x; }\""); 
							else
								echo tep_image($oListing['extra_gallery_url'], IMAGE_NOIMAGE, "", "", "name=\"extra_gallery_image\" onclick=\"var x = prompt('" . TEXT_GALLERY_URL . "', document.forms['listings'].extra_gallery_url.value); if(x && x.length > 0) { document.forms['listings'].extra_gallery_url.value = x; document.forms['listings'].extra_gallery_image.src = x; }\""); 
						?>
						</td>
					</tr>
					<tr>
	                  	<td class="main"><?php echo ENTRY_PICTURE1_URL ?>
							<?php echo tep_draw_hidden_field("picture1_url", $oListing['picture1_url']); ?>
						</td>
	        	        <td class="main">
							<?php
							if(strlen($oListing['picture1_url']) === 0)
								echo tep_image_button("noimage.gif", IMAGE_NOIMAGE, "name=\"picture1_image\" onclick=\"var x = prompt('" . TEXT_GALLERY_URL . "', document.forms['listings'].picture1_url.value); if(x && x.length > 0) { document.forms['listings'].picture1_url.value = x; document.forms['listings'].picture1_image.src = x; }\""); 
							else
								echo tep_image($oListing['picture1_url'], IMAGE_NOIMAGE, "", "", "name=\"picture1_image\" onclick=\"var x = prompt('" . TEXT_GALLERY_URL . "', document.forms['listings'].picture1_url.value); if(x && x.length > 0) { document.forms['listings'].picture1_url.value = x; document.forms['listings'].picture1_image.src = x; }\""); 
							?>
						</td>
					</tr>
					<tr>
		              <td class="main"><?php echo tep_draw_checkbox_field('extra_category_featured', '1', false, $oListing['extra_category_featured']) . ENTRY_CATEGORY_FEATURED; ?></td>
					</tr>
					<tr>
		              <td class="main"><?php echo tep_draw_checkbox_field('extra_homepage_featured', '1', false, $oListing['extra_homepage_featured']) . ENTRY_HOMEPAGE_FEATURED; ?></td>
					</tr>
					<tr>
		              <td class="main"><?php echo tep_draw_checkbox_field('extra_private', '1', false, $oListing['extra_private']) . ENTRY_PRIVATE_LISTING; ?></td>
					</tr>
					<tr>
		              <td class="main"><?php echo tep_draw_checkbox_field('extra_bold', '1', false,$oListing['extra_bold']) . ENTRY_BOLD_TITLE; ?></td>
					</tr>
					<tr>
		              <td class="main"><?php echo tep_draw_checkbox_field('extra_highlight', '1', false,$oListing['extra_highlight']) . ENTRY_HIGHLIGHT; ?></td>
					</tr>
					<tr>
		              <td class="main"><?php echo tep_draw_checkbox_field('counter', '1', false, $oListing['counter']) . ENTRY_COUNTER; ?></td>
					</tr>
					<tr>
					</tr>
				</table>	
				</div>
				</td>
			  </tr>
        </table>
		</td>
      </tr>
    </table></td>
	</form>
	
<!-- body_text_eof //-->
  </tr>
</table>
<!-- body_eof //-->
<!-- footer //-->
<?php
    require(DIR_WS_INCLUDES . 'footer.php');
?>
<!-- footer_eof //-->
<br>
</body>
</html>
<?php require(DIR_WS_INCLUDES . 'application_bottom.php'); ?>
