<?php
/*
  $Id: listings_active.php,v 1.2 2005/08/10 03:25:46 auctionblox Exp $

  AuctionBlox, sell more, work less!
  http://www.auctionblox.com

  Copyright (c) 2004 AuctionBlox
*/

  if (class_exists('abxPaginator_Listings') === false) {

    require_once(DIR_FS_ABX_PAGINATORS . 'listings.php');

  }

  class abxPaginator_Listings_Active extends abxPaginator_Listings {

    function tableDataHeadings()
    {
      return array(
        array('heading' => HEADING_LISTING_TITLE, 'sort_field' => 'ext_title'),
        array('heading' => HEADING_LISTING_ID, 'sort_field' => 'ext_id'),
        array('heading' => HEADING_LISTING_SITE, 'sort_field' => 'site'),
        array('heading' => HEADING_LISTING_TYPE, 'sort_field' => 'listing_type'),
        array('heading' => HEADING_LISTING_PRICE_END, 'sort_field' => 'current_price'),
        array('heading' => HEADING_LISTING_END_DATE, 'sort_field' => 'end_time'),
        array('heading' => HEADING_LISTING_QTY_SOLD),
        array('heading' => HEADING_LISTING_FEE, 'sort_field' => 'listing_fee')
      );
    }

    function tableDataRowContents($array)
    {
      global $currencies;

      $listingTypes = abxConstants::getListingTypesShort();

      return '<td>' . $this->cell('<a href="' . sprintf($array['url'], $array['ext_id']) . '" target="ebay">' . $this->cellWrap($array['ext_title'],150) . '</a>') . '</td>'.
             '<td>' . $this->cell($array['ext_id']) . '</td>'.
             '<td>' . $this->cell($array['site']) . '</td>'.
             '<td>' . $this->cell($listingTypes[$array['listing_type']]) . '</td>'.
             '<td align="right">' . $this->cell($currencies->format($array['current_price'], false, $array['currency'])) . '</td>'.
             '<td align="right">' . $this->cellWrapDate(gmt_date_to_local_pretty_format($array['end_time'])) . '</td>'.
             '<td align="right">' . $this->cell($array['quantity_sold'] . '&nbsp;/&nbsp;' . $array['quantity']) . '</td>'.
             '<td align="right">' . $this->cell($currencies->format($array['listing_fee'])) . '</td>';
    }

  }//end class
?>